/***************************************************************************
File name:  animal.h
Author:     chadd
Date:       Mar 22, 2011
Class:      CS 480
Purpose:		Demonstrate gcc's C++ name mangling and virtual function table

***************************************************************************/


#ifndef ANIMAL_H_
#define ANIMAL_H_

#include <stdio.h>

class animal {
  private:
    int weight;
  public:
    animal() ;
    animal(int w);
    virtual void makeSound() = 0 ;
    virtual int getWeight2() =0;
    virtual void hi();
    int getWeight() ;

    virtual int eat(animal &pA);

    void setWeight(int *w);

    // DANGER: the compiler cannot tell the following two
    // methods apart if they are called:
    // int x = 42;
    // pAn->setWeight(x);
    void setWeight(int w);
    void setWeight(int &w);



};

#endif /* ANIMAL_H_ */
